﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;
using System.Diagnostics;

namespace 全民k歌全自动监控工具精简版
{
    class Program
    {
        private static int count = 1;//次数
        private static ArrayList lst = new ArrayList();//定义集合储存歌手对象
        /// <summary>
        /// 将"uid:备注"的格式转换成Singer对象
        /// </summary>
        /// <param name="s"></param>
        /// <returns></returns>
        private static Singer GetSinger(string s)
        {
            string[] temp = s.Split(':');
            return (new Singer(temp[0], temp[1]));
        }
        /// <summary>
        /// 主方法
        /// </summary>
        /// <param name="args">运行参数,args[0]为延迟,args[1]为歌手列表</param>
        static void Main(string[] args)
        {
            Console.WriteLine("全民k歌全自动监控工具精简版v1.0\t作者:遗憾迟香\t吾爱破解论坛");
            try
            {
                if (args.Length != 2)
                {
                    Console.WriteLine("参数错误");
                    return;
                }
                Console.WriteLine("正在获取歌手信息");
                string[] str = File.ReadAllLines(args[1],Encoding.Default);//读取文件
                foreach (string t in str)
                {
                    if (t == ""||t.Contains("//")) { continue; }
                    if (t.Contains(":"))
                    { lst.Add(GetSinger(t)); }//带备注
                    else { lst.Add(new Singer(t)); }//不带备注
                }
                if (lst.Count == 0)
                { 
                    Console.WriteLine("您未添加任何歌手");
                    return;
                }
                foreach (Singer t in lst)
                {//循环遍历显示歌手信息
                    Console.WriteLine("uid:{0}\t昵称:{1}\t最大时间戳:{2}", t.Uid, t.Name, t.TMax);
                }
                Console.WriteLine("已开始");
                while (true)
                {//定时器
                    foreach (Singer t in lst)
                    {//循环遍历监控歌手
                        Console.Write("第{0}次监控\t",count);
                        Console.WriteLine("\t{0}\t{1}", t.Monit(),DateTime.Now);
                    }
                    count++;
                    Thread.Sleep(int.Parse(args[0]));//延迟
                }
            }
            catch (Exception err)
            {
                Console.WriteLine(err.Message);
            }
            finally
            {
                Console.WriteLine("按任意键退出");
                Console.ReadKey();
            }
        }


    }
}
