﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace 全民k歌全自动监控工具精简版
{
    public class Singer
    {
        //查询链接
        private const string CGI = "http://cgi.kg.qq.com/fcgi-bin/kg_ugc_get_homepage?jsonpCallback=callback_0&inCharset=GB2312&outCharset=utf-8&g_tk=5381&g_tk_openkey=5381&type=get_uinfo&start=1&num=8&touin=&share_uid=";

        private string src;
        //网页源码
        public string Src
        {
            get { return GetS(CGI + uid.Trim()); }
            set { src = value; }
        }
        private string uid;

        public string Uid
        {
            get { return uid; }
            set { uid = value; }
        }

        private string name;
        //歌手名
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        //最大时间戳
        private int tMax;

        public int TMax
        {
            get { return tMax; }
            set { tMax = value; }
        }



        /// <summary>
        /// Singer有参构造
        /// </summary>
        /// <param name="uid">uid</param>
        public Singer(string uid)
        {
            this.uid = uid;
            this.src = GetS(CGI + uid.Trim());
            if (src.Contains("参数错误") || !src.Contains("ok"))
            {
                Console.WriteLine("{0}\nuid:{1}\n请检查网络连接以及输入的uid是否正确\n按任意键退出", src, uid);
                Console.ReadKey();
                Process.GetCurrentProcess().Kill();
            }
            this.tMax = GetTime(this.src, -1);
            this.name = GetMiddleText(this.src, "\"nickname\": \"", "\", \"sCityId");
        }
        /// <summary>
        /// Singer有参构造(有备注)
        /// </summary>
        /// <param name="uid">uid</param>
        /// <param name="name">备注</param>
        public Singer(string uid, string name)
        {
            this.uid = uid;
            this.name = name;
            this.src = GetS(CGI + uid.Trim());
            if (src.Contains("参数错误") || !src.Contains("ok"))
            {
                Console.WriteLine("{0}\nuid:{1}\n请检查网络连接以及输入的uid是否正确\n按任意键退出", src, uid);
                Console.ReadKey();
                Process.GetCurrentProcess().Kill();
            }
            this.tMax = GetTime(this.src, -1);
        }

        /// <summary>
        /// 监控
        /// </summary>
        /// <returns>返回是否检测到新作品</returns>
        public bool Monit()
        {
            Console.Write(name);
            src = GetS(CGI + uid);
            int t = GetTime(src, tMax);
            if (t > tMax)
            {//发现新作品,准备下载
                Console.WriteLine("准备下载");
                Thread.Sleep(3000);//作品发上去的一瞬间,服务器上可能没有文件
                string url = GetNew(src, tMax);
                Console.WriteLine(url);
                tMax = Download(url, tMax);
                return true;
            }
            return false;
        }

        /// <summary>
        /// 获取网页源码
        /// </summary>
        /// <param name="url">url</param>
        /// <returns></returns>
        private static string GetS(string url)
        {
            string message = string.Empty;
            HttpWebRequest request;
            try
            {
                request = (HttpWebRequest)WebRequest.Create(url);
                request.Accept = "text/html, application/xhtml+xml, */*";
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)";
                request.KeepAlive = true;
                request.ProtocolVersion = HttpVersion.Version11;
                ServicePointManager.Expect100Continue = false;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream responseStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, Encoding.GetEncoding("UTF-8"));
                message = reader.ReadToEnd();
                reader.Close();
                responseStream.Close();
            }
            catch (Exception err)
            {
                message = err.Message;
            }
            finally { GC.Collect(); }
            return message;
        }

        /// <summary>
        /// 获取网页源码
        /// </summary>
        /// <param name="url">url</param>
        /// <param name="en">编码</param>
        /// <returns></returns>
        public static string GetS(string url, Encoding en)
        {
            string message = string.Empty;
            HttpWebRequest request;
            try
            {
                request = (HttpWebRequest)WebRequest.Create(url);
                request.Accept = "text/html, application/xhtml+xml, */*";
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)";
                request.KeepAlive = true;
                request.ProtocolVersion = HttpVersion.Version11;
                ServicePointManager.Expect100Continue = false;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream responseStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, en);
                message = reader.ReadToEnd();
                reader.Close();
                responseStream.Close();
            }
            catch (Exception err)
            {
                message = err.Message;
            }
            finally { GC.Collect(); }
            return message;
        }

        /// <summary>
        /// 下载文件，若目标已存在则覆盖，文件名非法则不会下载
        /// </summary>
        /// <param name="path">目录</param>
        /// <param name="url">下载地址</param>
        [DllImport("Wesing.dll")]
        private static extern void Down(string path, string url);

        /// <summary>
        /// 取出中间字符串
        /// </summary>
        /// <param name="str">源字符串</param>
        /// <param name="leftStr">左</param>
        /// <param name="rightStr">右</param>
        /// <returns></returns>
        private static string GetMiddleText(string str, string leftStr, string rightStr)
        {
            if (str == "" || leftStr == "" || rightStr == "") { return null; }
            int a = str.IndexOf(leftStr, 0);
            int b = str.IndexOf(rightStr, a + 1);
            if (a < 0 || b < 0)
            { return null; }
            else
            {
                a = a + leftStr.Length;
                b = b - a;
                if (a < 0 || b < 0)
                { return null; }
                return str.Substring(a, b);
            }
        }

        /// <summary>
        /// 获取最大时间戳
        /// </summary>
        /// <param name="s">源码</param>
        /// <param name="potectTime">受保护的时间戳</param>
        /// <returns>成功则返回时间戳，失败则返回保护的时间戳</returns>
        [DllImport("Wesing.dll")]
        private static extern int GetTime(string s, int potectTime);

        [DllImport("Wesing.dll", CharSet = CharSet.Ansi)]
        private static extern IntPtr GetUrl(string s, int t0);

        /// <summary>
        /// 获取最新作品链接
        /// </summary>
        /// <param name="s">源码</param>
        /// <param name="t0">最大时间</param>
        /// <returns>返回最新作品链接</returns>
        private static string GetNew(string s, int t0)
        {
            return Marshal.PtrToStringAnsi(GetUrl(s, t0));
        }

        /// <summary>
        /// 下载作品
        /// </summary>
        /// <param name="url">作品链接</param>
        /// <param name="ctime">要保护的时间戳</param>
        /// <returns>返回作品的时间戳</returns>
        private int Download(string url, int ctime)
        {
            Console.WriteLine("正在下载中");
            Random rd = new Random();
            try
            {
                string s = GetS(url);
                ctime = int.Parse(GetMiddleText(s, "ctime\":", ",\"f_lat\":"));//时间戳
                string songName = GetMiddleText(s, "<h2 class=\"play_name\">", "</h2>");//歌名
                string DownUrl;
                if (s.Contains(".mp4")) { DownUrl = GetMiddleText(s, "playurl_video\":\"", "&fromtag"); }
                else
                { DownUrl = GetMiddleText(s, "playurl\":\"", "&fromtag"); }//下载地址
                string rand = rd.Next().ToString();//生成随机数
                if (File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), name, songName)))
                { name += rand; }//目标文件已存在,使用随机数重命名
                Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), name, songName), DownUrl);
                if (!File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), name, songName)))
                { //歌手名存在非法字符,启动备用下载
                    Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, songName), DownUrl);
                    if (!File.Exists(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, songName)))
                    {//歌名存在非法字符,启动备用下载
                        Down(string.Format("{0}\\{1}-{2}.m4a", Directory.GetCurrentDirectory(), rand, rd.Next()), DownUrl);
                    }
                }
                if (!DownUrl.Contains("http"))
                { Console.WriteLine("下载失败,下载地址有误:{0}", DownUrl); }
                else
                { Console.WriteLine("下载成功:{0},最大时间戳为{1}", songName, tMax); }
                return ctime;
            }
            catch (Exception err)
            {
                Console.WriteLine("下载失败," + err.Message);
                return ctime;
            }
        }
    }
}
